
import request from '@/utils/request'

export interface IRewardData {
  _id?: string
  id?: number
  rank?: number
  rankEnd?: number
  coupon?: string
  count?: number
  type?: number
  rewardType?: number
}

export interface IActivityData {
  _id?: string
  shop: string
  name: string
  desc?: string
  icon?: string
  banner?: string
  qtypes: string[]
  qcount: number
  repeatType: number
  monthDays: number[]
  weekDays: number[]
  beginTime: number[]
  prepareTime: number
  active: boolean
  beginDays: number[]
  beginDay?: number
  endDay?: number
  rewardInfo: IRewardData[]
}

export const defaultRewardData: IRewardData = {
  count: 1,
  type: 0,
  rewardType: 0
}

export const defaultActivityData: IActivityData = {
  beginDays: [],
  active: false,
  beginTime: [],
  monthDays: [],
  weekDays: [],
  name: '',
  prepareTime: 0,
  qcount: 0,
  qtypes: [],
  repeatType: 0,
  shop: '',
  rewardInfo: []

}

export const getActivitys = (params: any) =>
  request({
    url: '/api/activitys',
    method: 'post',
    params
  })

export const getActivity = (id: string, params: any) =>
  request({
    url: `/api/activity/${id}`,
    method: 'get',
    params
  })

export const saveActivity = (data: any) =>
  request({
    url: '/api/activity/save',
    method: 'post',
    data
  })

export const deleteActivity = (id: string) =>
  request({
    url: `/api/activity/${id}/delete`,
    method: 'post'
  })

export const publishActivity = (data: any) =>
  request({
    url: '/api/activity/publish',
    method: 'post',
    data
  })
