import request from '@/utils/request'
import { UserModule } from '@/store/modules/user'
export interface IAdmin {
  id: string
  username: string
  address?: string
  showname: string
  comment: string
  locked: boolean
  roles: string[]
  sex: string
  avatar: string
  password: string
  department: string
  level: number
}

export const defaultAdmin: IAdmin = {
  id: '',
  username: '',
  address: '',
  showname: '',
  comment: '',
  locked: false,
  roles: [],
  level: 1,
  sex: '0',
  password: '',
  avatar: '',
  department: ''
}
export const getAdminInfo = (data: any) =>
  request({
    url: '/api/admin/info',
    method: 'post',
    data
  })

export const login = (data: any) =>
  request({
    url: '/api/admin/login',
    method: 'post',
    data
  })

export const loginWallet = (data: any) =>
  request({
    url: '/api/admin/wallet_login',
    method: 'post',
    data
  })
export const logout = () =>
  request({
    url: '/api/admin/logout',
    method: 'post'
  })

export const saveAdmin = (data: any) =>
  request({
    url: '/api/admin/save',
    method: 'post',
    data
  })

export const deleteAdmin = (uid: string) => {
  return request({
    url: `/api/admin/${uid}/delete`,
    method: 'post'
  })
}

export const changeLocker = (uid: string, status: boolean) => {
  return request({
    url: `/api/admin/${uid}/locker`,
    method: 'post',
    data: { lock: status }
  })
}

export const getUsers = (params: any) =>
  request({
    url: '/api/admins',
    method: 'get',
    params
  })

export const simpleUsers = (params: any) =>
  request({
    url: '/api/simple_admins',
    method: 'get',
    params
  })

export const changePass = (params: any) =>
  request({
    url: '/api/admin/passwd',
    method: 'post',
    data: params
  })

export const changeInfo = (params: any) =>
  request({
    url: '/api/admin/update_info',
    method: 'post',
    data: params
  })

export const getNonce = (params: any) =>
  request({
    url: '/api/admin/wallet_nonce',
    method: 'get',
    params: params
  })
