
import request from '@/utils/request'

export interface IAnnounceData {
  _id?: string
  shop?: string
  title?: string
  content?: string
  type: number
  accounts: string[]
  shops: string[]
  sendTime?: number
  endTime?: number
}

export const defaultAnnounceData: IAnnounceData = {
  shops: [],
  type: 0,
  accounts: []
}

export const getAnnounces = (params: any) =>
  request({
    url: '/api/announces',
    method: 'post',
    params
  })

export const getAnnounce = (id: string, params: any) =>
  request({
    url: `/api/announce/${id}`,
    method: 'get',
    params
  })

export const saveAnnounce = (data: any) =>
  request({
    url: '/api/announce/save',
    method: 'post',
    data
  })

export const deleteAnnounce = (data: any) =>
  request({
    url: '/api/announce/delete',
    method: 'post',
    data
  })

export const publishAnnounce = (data: any) =>
  request({
    url: '/api/announce/publish',
    method: 'post',
    data
  })
