import request from '@/utils/request'
import { IArticleData } from './types'

export const defaultArticleData: IArticleData = {
  id: '',
  title: '',
  content: '',
  summary: '',
  source: '',
  sourceUrl: '',
  displayTime: '',
  tags: [],
  keywords: [],
  sortno: 0,
  author: '',
  type: '',
  attachments: []
}

export const getArticles = (params: any) =>
  request({
    url: '/api/articles',
    method: 'post',
    params
  })

export const getArticle = (id: number, params: any) =>
  request({
    url: `/api/articles/${id}`,
    method: 'get',
    params
  })

export const createArticle = (data: any) =>
  request({
    url: '/api/articles',
    method: 'post',
    data
  })

export const updateArticle = (id: number, data: any) =>
  request({
    url: `/api/articles/${id}`,
    method: 'put',
    data
  })

export const deleteArticle = (id: number) =>
  request({
    url: `/api/articles/${id}`,
    method: 'delete'
  })

export const getPageviews = (params: any) =>
  request({
    url: '/api/pageviews',
    method: 'get',
    params
  })
