import request from '@/utils/request'

export enum AssetsType {
  ERC20 = 1,
  ERC721 = 2,
  ERC1155 = 3,
  OTHER = 9
}

export interface IAssetData {
  _id?: string
  name: string
  createdAt?: Date
  type: AssetsType
  address: string
  comment?: string
}

export const defaultAssetsData: IAssetData = {
  name: '',
  address: '',
  type: AssetsType.OTHER
}

export const getAssets = (data: any) =>
  request({
    url: '/api/chain/assets',
    method: 'post',
    data
  })

export const saveAsset = (data: any) =>
  request({
    url: '/api/chain/asset',
    method: 'post',
    data
  })

export const deleteAssets = (data: any) =>
  request({
    url: '/api/chain/asset',
    method: 'delete',
    data
  })

export const getAsset = (id: string) =>
  request({
    url: `/api/chain/asset/${id}`,
    method: 'get'
  })
