import request from '@/utils/request'

export interface ICouponData {
  _id?: string
  name: string
  createdAt?: Date
  shop: string
  content: string
  comment?: string
  total: number
  count: number
  validBegin?: number
  validEnd?: number
  validDays?: number
  limitOne: number
  image?: string
}

export const defaultCouponData: ICouponData = {
  shop: '',
  name: '',
  content: '',
  total: 0,
  count: 0,
  limitOne: 0,
  validDays: 0
}

export const getCoupons = (params: any) =>
  request({
    url: '/api/coupons',
    method: 'post',
    params
  })

export const getCoupon = (id: string, params: any) =>
  request({
    url: `/api/coupon/${id}`,
    method: 'get',
    params
  })

export const saveCoupon = (data: any) =>
  request({
    url: '/api/coupon/save',
    method: 'post',
    data
  })

export const deleteCoupon = (id: string) =>
  request({
    url: `/api/coupon/${id}/delete`,
    method: 'post'
  })
