import request from '@/utils/request'
import { IRewardData } from '@/api/activity'

export interface IExamQuerstion {
  _id?: string
  question: string
  a1: string
  a2?: string
  a3?: string
  a4?: string
  type: number
}

export interface IExamData {
  _id?: string
  shop: string
  name: string
  desc?: string
  icon?: string
  banner?: string
  qtypes: string[]
  shopCates: string[]
  qcount: number
  timeone: number
  beginTime: number
  endTime: number
  active: number
  source: number
  qrate: number
  rewardInfo: IRewardData[]
  questions: IExamQuerstion[]
}

export const defaultExamData: IExamData = {
  active: 0,
  beginTime: 0,
  endTime: 1924963201000,
  timeone: 5,
  name: '',
  qcount: 10,
  qtypes: [],
  shop: '',
  source: 0,
  rewardInfo: [],
  shopCates: [],
  questions: [],
  qrate: 0
}

export const getExams = (params: any) =>
  request({
    url: '/api/exams',
    method: 'post',
    params
  })

export const getExam = (id: string, params: any) =>
  request({
    url: `/api/exam/${id}`,
    method: 'get',
    params
  })

export const saveExam = (data: any) =>
  request({
    url: '/api/exam/save',
    method: 'post',
    data
  })

export const deleteExam = (id: string) =>
  request({
    url: `/api/exam/${id}/delete`,
    method: 'post'
  })
