import request from '@/utils/request'

export interface IFlowTaskData {
  _id?: string
  node: string
  executors: string[]
  name?: string
  type?: number
  action?: string
}

export interface IFlowDefData {
  _id?: string
  name: string
  category: string
  createdAt?: Date
  nodeCount: number
  nodes: IFlowTaskData[]
  form?: string
  formName?: string
  createdBy?: string
}

export const defaultDefData: IFlowDefData = {
  name: '',
  category: '',
  nodeCount: 0,
  nodes: []
}

export const defaultFlowTask: IFlowTaskData = {
  node: '',
  executors: []
}

export const getFlowDefinitions = (data: any) =>
  request({
    url: '/api/flow/definitions',
    method: 'post',
    data
  })

export const myFlowDefinitions = (data: any) =>
  request({
    url: '/api/flow/mydefinitions',
    method: 'post',
    data
  })

export const saveFlowDefinition = (data: any) =>
  request({
    url: '/api/flow/definition',
    method: 'post',
    data
  })

export const deleteFlowDefinitions = (data: any) =>
  request({
    url: '/api/flow/definition',
    method: 'delete',
    data
  })

export const getFlowDefinition = (id: string) =>
  request({
    url: `/api/flow/definition/${id}`,
    method: 'get'
  })

export const getFlowDefDetail = (id: string) =>
  request({
    url: `/api/flow/definition/${id}`,
    method: 'post'
  })
