import request from '@/utils/request'
export enum DataTypeEnum {
  string = 0,
  number = 1,
  datetime = 2,
  date = 3,
  time = 4,
  address = 5,
  other = 9
}
export interface IFlowFormInput {
  keyid: string
  name: string
  defaultVal: string
  values: string[]
  dataType: DataTypeEnum
  index: number
  unique: boolean
  addressType: string[]
}

export interface IFlowFormData {
  _id?: string
  name: string
  nodes: IFlowFormInput[]
}

export const defaulFormInput: IFlowFormInput = {
  keyid: '',
  name: '',
  defaultVal: '',
  values: [],
  dataType: DataTypeEnum.string,
  index: 999,
  unique: false,
  addressType: []
}

export const defaultFormData: IFlowFormData = {
  name: '',
  nodes: []
}

export const getFlowForms = (data: any) =>
  request({
    url: '/api/flow/forms',
    method: 'post',
    data
  })

export const saveFlowForm = (data: any) =>
  request({
    url: '/api/flow/form',
    method: 'post',
    data
  })

export const deleteFlowForms = (data: any) =>
  request({
    url: '/api/flow/form',
    method: 'delete',
    data
  })

export const getFlowForm = (id: string) =>
  request({
    url: `/api/flow/form/${id}`,
    method: 'get'
  })
