import request from '@/utils/request'

export interface IFlowNodeData {
  _id?: string
  name: string
  type: number
  createdAt?: Date
  createdBy?: string
  action?: string
}

export const defaultNodeData: IFlowNodeData = {
  name: '',
  type: 0
}

export const getFlowNodes = (data: any) =>
  request({
    url: '/api/flow/nodes',
    method: 'post',
    data
  })

export const saveFlowNode = (data: any) =>
  request({
    url: '/api/flow/node',
    method: 'post',
    data
  })

export const deleteFlowNodes = (data: any) =>
  request({
    url: '/api/flow/node',
    method: 'delete',
    data
  })

export const getFlowNode = (id: string) =>
  request({
    url: `/api/flow/node/${id}`,
    method: 'get'
  })

export const getFlowActions = () =>
  request({
    url: '/api/flow/actions',
    method: 'get'
  })
