import request from '@/utils/request'
export interface IGameVersion {
  _id?: string
  type: number
  name: string
  url?: string
  appid?: string
  appsecret?: string
  image?: string
  selected?: boolean
  qr?: string
}
export interface IGameData {
  _id?: string
  name: string
  createdAt?: Date
  versions: IGameVersion[]
  selected?: boolean
}

export const defaultGameVersionData: IGameVersion = {
  type: 0,
  name: ''
}

export const defaultGameData: IGameData = {
  versions: [defaultGameVersionData],
  name: ''
}

export const getGames = (params: any) =>
  request({
    url: '/api/games',
    method: 'post',
    params
  })

export const getGame = (id: string, params: any) =>
  request({
    url: `/api/game/${id}`,
    method: 'get',
    params
  })

export const saveGame = (data: any) =>
  request({
    url: '/api/game/save',
    method: 'post',
    data
  })

export const deleteGame = (id: string) =>
  request({
    url: `/api/game/${id}/delete`,
    method: 'post'
  })
