
import request from '@/utils/request'

export interface IMailItem {
  _id?: string
  index?: number
  itemId?: string
  name?: string
  count: number
}

export interface IMailData {
  _id?: string
  senderShop?: string
  sender?: string
  title?: string
  content?: string
  type: number
  accounts: string[]
  shops: string[]
  items: IMailItem[]
  sendTime?: number
  endTime?: number
}

export const defaultMailItem: IMailItem = {
  count: 1
}

export const defaultMailData: IMailData = {
  items: [],
  shops: [],
  type: 0,
  accounts: []
}

export const getMails = (params: any) =>
  request({
    url: '/api/mails',
    method: 'post',
    params
  })

export const getMail = (id: string, params: any) =>
  request({
    url: `/api/mail/${id}`,
    method: 'get',
    params
  })

export const saveMail = (data: any) =>
  request({
    url: '/api/mail/save',
    method: 'post',
    data
  })

export const deleteMail = (data: any) =>
  request({
    url: '/api/mail/delete',
    method: 'post',
    data
  })
