import request from '@/utils/request'

export interface IQuestionData {
  _id?: string
  question: string
  a1: string
  a2?: string
  a3?: string
  a4?: string
  groups?: string[]
  tag?: string
  sub_tag?: string
  category?: string
  quality: number
  withNext: boolean
  shop?: string
  status?: number
}

export const defaultQuestionData: IQuestionData = {
  withNext: false,
  quality: 3,
  a1: '',
  question: ''

}

export function formatQType(val: number) {
  switch (val) {
    case 1:
      return '普通'
    case 2:
      return '图片'
    case 3:
      return '问卷'
    default:
      return '未知'
  }
}

export const getQuestions = (params: any) =>
  request({
    url: '/api/puzzles',
    method: 'post',
    params
  })

export const getQuestion = (id: string, params: any) =>
  request({
    url: `/api/puzzle/${id}`,
    method: 'get',
    params
  })
export const nextQuestion = (id: string) =>
  request({
    url: '/api/nextpuzzle',
    method: 'post',
    data: { id }
  })

export const saveQuestion = (data: any) =>
  request({
    url: '/api/puzzle/save',
    method: 'post',
    data
  })

export const deleteQuestion = (id: string) =>
  request({
    url: `/api/puzzle/${id}/delete`,
    method: 'post'
  })

export const getAllTags = () =>
  request({
    url: '/api/tags',
    method: 'get'
  })

export const saveTag = (name: string) =>
  request({
    url: '/api/tag/save',
    method: 'post',
    data: { name }
  })

export const getAllCategory = () =>
  request({
    url: '/api/question/categorys',
    method: 'get'
  })
