import request from '@/utils/request'
import { IShopData } from './types'

export const defaultShopData: IShopData = {
  name: '',
  address: '',
  logo: '',
  local: 0,
  qtypes: []
}

export const getShops = (params: any) =>
  request({
    url: '/api/depts',
    method: 'post',
    params
  })

export const getShop = (id: string, params: any) =>
  request({
    url: `/api/dept/${id}`,
    method: 'get',
    params
  })

export const getMyShop = () =>
  request({
    url: '/api/mydept',
    method: 'get'
  })

export const saveShop = (data: any) =>
  request({
    url: '/api/dept/save',
    method: 'post',
    data
  })

export const deleteShop = (id: string) =>
  request({
    url: `/api/dept/${id}/delete`,
    method: 'post'
  })
