import request from '@/utils/request'

export const getShopQuestions = (data: any) =>
  request({
    url: `/api/${data.shop}/puzzles`,
    method: 'post',
    data
  })

export const getShopQuestion = (shop: string, id: string, params: any) =>
  request({
    url: `/api/${shop}/puzzle/${id}`,
    method: 'get',
    params
  })
export const nextShopQuestion = (shop: string, id: string) =>
  request({
    url: `/api/${shop}/nextpuzzle`,
    method: 'post',
    data: { id }
  })

export const saveShopQuestion = (data: any) =>
  request({
    url: `/api/${data.shop}/puzzle/save`,
    method: 'post',
    data
  })

export const importQuestions = (shop: string, data: any) =>
  request({
    url: `/api/${shop}/puzzle/import`,
    method: 'post',
    data
  })

  /**
   * update shop puzzle review status
   */
export const updateQuestionStatus = (shop: string, data: any) =>
  request({
    url: `/api/${shop}/puzzle/review`,
    method: 'post',
    data
  })

export const deleteShopQuestion = (shop: string, ids: string[]) =>
  request({
    url: `/api/${shop}/puzzle/delete`,
    method: 'post',
    data: { ids }
  })

export const getShopCategory = (shop: string) =>
  request({
    url: `/api/${shop}/categorys`,
    method: 'get'
  })
