import { RouteConfig } from 'vue-router'
import Layout from '@/layout/index.vue'

const articleRouters: RouteConfig = {
  path: '/article',
  component: Layout,
  redirect: '/article/list',
  meta: {
    title: 'article',
    icon: 'list',
    alwaysShow: true
  },
  children: [
    {
      path: 'create',
      component: () => import(/* webpackChunkName: "example-create" */ '@/views/article/create.vue'),
      name: 'CreateArticle',
      meta: {
        title: 'createArticle',
        icon: 'edit'
      }
    },
    {
      path: 'edit/:id(\\d+)',
      component: () => import(/* webpackChunkName: "example-edit" */ '@/views/article/edit.vue'),
      name: 'EditArticle',
      meta: {
        title: 'editArticle',
        noCache: true,
        activeMenu: '/article/list',
        hidden: true
      }
    },
    {
      path: 'list',
      component: () => import(/* webpackChunkName: "example-list" */ '@/views/article/list.vue'),
      name: 'ArticleList',
      meta: {
        title: 'articleList',
        icon: 'list'
      }
    }
  ]
}

export default articleRouters
