import { RouteConfig } from 'vue-router'
import Layout from '@/layout/index.vue'

const chainRoutes: RouteConfig = {
  path: '/chain',
  component: Layout,
  meta: {
    title: 'chain_mgr',
    icon: 'workflow',
    permissions: ['assets:*'],
    alwaysShow: true
  },
  children: [
    {
      path: 'chain_assets',
      component: () => import('@/views/chain/list.vue'),
      name: 'ChainAssets',
      meta: {
        title: 'chain_assets',
        permissions: ['assets:read'],
        icon: 'game'
      }
    },
    {
      path: 'asset_new',
      component: () => import('@/views/chain/form.vue'),
      name: 'CreateChainAsset',
      meta: {
        title: 'create_asset',
        icon: 'edit',
        permissions: ['assets:edit'],
        hidden: true
      }
    },
    {
      path: 'asset_edit/:id',
      component: () => import('@/views/chain/form.vue'),
      name: 'ChainAssetEditor',
      meta: {
        title: 'edit_asset',
        permissions: ['assets:read'],
        elicon: 'el-icon-arrow-right',
        hidden: true
      }
    }
  ]
}

export default chainRoutes
