import { RouteConfig } from 'vue-router'
import Layout from '@/layout/index.vue'

const staticsRoutes: RouteConfig = {
  path: '/statistics',
  component: Layout,
  meta: {
    title: 'shop_statistics',
    icon: 'statistics',
    alwaysShow: true,
    permissions: ['statistics:*']
  },
  children: [
    {
      path: 'gamestatistics',
      component: () => import('@/views/error-page/401.vue'),
      name: 'GameStatistics',
      meta: {
        title: 'token_statistics',
        permissions: ['statistics:read'],
        icon: 'game'
      }
    }
  ]
}
export default staticsRoutes
