import { RouteConfig } from 'vue-router'
import Layout from '@/layout/index.vue'

const logRoutes: RouteConfig = {
  path: '/log',
  component: Layout,
  meta: {
    title: 'log_sys',
    icon: 'sys_log',
    permissions: ['log:*'],
    alwaysShow: true
  },
  children: [
    {
      path: 'log_login',
      component: () => import('@/views/error-page/401.vue'),
      name: 'LogLogin',
      meta: {
        title: 'log_login',
        permissions: ['log:read'],
        icon: 'game'
      }
    },
    {
      path: 'log_operate',
      component: () => import('@/views/error-page/401.vue'),
      name: 'LogOperate',
      meta: {
        title: 'log_operate',
        permissions: ['log:read'],
        icon: 'flow_setting'
      }
    },
    {
      path: 'log_token_mint',
      component: () => import('@/views/error-page/401.vue'),
      name: 'LogTokenMint',
      meta: {
        title: 'log_token_mint',
        permissions: ['log:read'],
        icon: 'flow_setting'
      }
    },
    {
      path: 'log_nft_mint',
      component: () => import('@/views/error-page/401.vue'),
      name: 'LogNftMint',
      meta: {
        title: 'log_nft_mint',
        permissions: ['log:read'],
        icon: 'flow_setting'
      }
    }
  ]
}

export default logRoutes
