import { UserModule } from '@/store/modules/user'

export const checkRole = (value: string[]): boolean => {
  if (value && value instanceof Array && value.length > 0) {
    const roles = UserModule.roles
    const permissionRoles = value
    const hasPermission = roles.some(role => {
      return permissionRoles.includes(role)
    })
    return hasPermission
  } else {
    console.error('need roles! Like v-permission="[\'admin\',\'editor\']"')
    return false
  }
}

export const checkPermission = (value: string[]): boolean => {
  if (value && value instanceof Array && value.length > 0) {
    const permissions = UserModule.permissions
    let hasPermission = false
    for (const sub of value) {
      if (sub === '*') {
        hasPermission = true
        break
      }
      const subArr = sub.split(':')
      if (subArr[0] === '*') {
        for (const p of permissions) {
          if (p[1] === '*' || p[1] === subArr[1]) {
            hasPermission = true
            break
          }
        }
      } else if (subArr[1] === '*') {
        for (const p of permissions) {
          if (p[0] === '*' || p[0] === subArr[0]) {
            hasPermission = true
            break
          }
        }
      } else {
        for (const p of permissions) {
          if ((p[0] === '*' && p[1] === '*') ||
            (p[0] === '*' && p[1] === subArr[1]) ||
            (p[0] === subArr[0] && p[1] === '*') ||
            (p[0] === subArr[0] && p[1] === subArr[1])) {
            hasPermission = true
            break
          }
        }
      }
      if (hasPermission) {
        break
      }
    }
    return hasPermission
  } else {
    console.error('need roles! Like v-permission="[\'admin\',\'editor\']"')
    return false
  }
}
