import Vue from 'vue'

const local = {
  get: function(key: string) {
    const val = localStorage.getItem(key)
    if (val) {
      return JSON.parse(val)
    } else {
      return null
    }
  },
  set: function(key: string, val: any) {
    localStorage.setItem(key, JSON.stringify(val))
  }
}
export default {
  install: function(vue: typeof Vue) {
    vue.prototype.$local = local
  }
}
/**
 * 最后编辑的店铺
 * @type {string}
 */
export const LAST_SHOP = 'last_edit_shop'
